#!/usr/local/bin/perl

# TrackBack receiver for a-News with Kuttuki BBS
# Ver. 20040811

# BBS̐ݒt@C̃pXw
my $conf_file = "kuttukibbsconf.cgi";

# f[^t@C̃pX(Ō/͓Ȃ)
# ̃XNvg̑΃pX΃pX
$site_path = "data";
# index.html̂fBNg̃pX(Ō/͓Ȃ)
# ̃XNvg̑΃pX΃pX
$index_path = ".";

# CGI.pmJcode.pm̏ꏊw
# ftHgPerlTꏊɃCXg[ςȂsv
use lib "./pm";

# LID̃t@C̗L`FbN
if ($ENV{'PATH_INFO'}) {
	if ($ENV{'PATH_INFO'} =~ /^\/(\d\d\d\d)-(\d\d)-(\d\d)$/) {
		$file = $site_path . '/' . $1 . '/' . $2 . '/' . $3 . '.html';
	} else {
		$file = $index_path . $ENV{'PATH_INFO'} . '.html';
	}
	unless (-e $file) {
		&error('Entry ID is irregular.');
	}
} else {
	&error('Entry ID is missing.');
}

### O[oϐ
my $latest_id = -1;		# ŐṼRg ID
my %com_hash;			# Rgi[nbV
my $URLCHARS = "[-_.!~*'a-zA-Z0-9;/?:@&=+,%\#\$]";
my $kb_js_strlen_max;
my $log_dir;

use CGI;
my $q = new CGI;
my $title = $q->param('title');
my $url = $q->param('url');
my $blog_name = $q->param('blog_name');
my $excerpt = $q->param('excerpt');
my $charset = $q->param('charset');
my $moderss = $q->param('__mode');

# QUERY_STRING̗LmF
if ($moderss ne "rss" && $url eq "") {
	&error('QUERY_STRING is missing.');
}

use Jcode;

# [Uݒt@C̓ǂݍ
if (not -e $conf_file) {
    print "error: can't read $conf_file\n";
    exit;
}
open(CONF, "$conf_file") or die "can't open $conf_file : $!";
my $conf = join('', <CONF>);
eval $conf;

### ǂݍ
$logid = $ENV{'PATH_INFO'};
$logid =~ s/^\///;
$fn_pref = $log_dir . $ENV{'PATH_INFO'};
$fn = "$fn_pref.log";
read_file($fn, \$all);
set_comment_hash(\%com_hash, \$all);

if ($ENV{'REQUEST_METHOD'} eq 'GET') {
	if ($moderss eq 'rss') {
		my $tb_list_rss;
		my $tb_list;
		for (my $i = $latest_id; $i >= 0; $i--) {
			next unless defined $com_hash{$i};
			$tb_list .= &make_tb_list_rss($com_hash{$i}, $i + 1);
		}

# --------------------------------------------------------------------
# TrackBackXgRSSo͂̃ev[g
my $rss_template = << 'END'
Content-type: text/xml

<?xml version="1.0" encoding="utf-8"?>
<response>
<error>0</error>
<rss version="0.91">
<channel>
<title>TrackBack list of $logid</title>
<link>http://$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}$ENV{'PATH_INFO'}</link>
<description>TrackBack list of $logid</description>
$tb_list
</channel>
</rss>
</response>
END
   ;

		eval qq(\$tb_list_rss = << "FFF"\n$rss_template\nFFF\n);
		print $tb_list_rss;
		exit;
	} else {
		&error('TrackBack Ping must be sent POST method.');
	}
} elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {

# NURLTrackBack PingƂď
	if ($url) {

# URLhttp://Ŏn܂ĂȂ΃G[
		unless ($url =~ /^http:\/\/\S+$/) {
			&error('Client URL is irregular.');
		}

# R[hϊ
		if ($charset eq 'utf-8' || $charset eq 'utf8') {
			$title = Jcode->new($title,'utf8')->sjis;
			$blog_name = Jcode->new($blog_name,'utf8')->sjis;
			$excerpt = Jcode->new($excerpt,'utf8')->sjis;
		} elsif ($charset eq 'euc' || $charset eq 'euc-jp') {
			$title = Jcode->new($title,'euc')->sjis;
			$blog_name = Jcode->new($blog_name,'euc')->sjis;
			$excerpt = Jcode->new($excerpt,'euc')->sjis;
		} elsif ($charset eq 'jis' || $charset eq 'iso-2022-jp') {
			$title = Jcode->new($title,'jis')->sjis;
			$blog_name = Jcode->new($blog_name,'jis')->sjis;
			$excerpt = Jcode->new($excerpt,'jis')->sjis;
		} else {
			$title = Jcode->new($title)->sjis;
			$blog_name = Jcode->new($blog_name)->sjis;
			$excerpt = Jcode->new($excerpt)->sjis;
		}

# ݎ̊l
		use POSIX qw(strftime);
		my $what_time_is_it_now = strftime "%Y-%m-%d %H:%M:%S", localtime;

# ݏ
		if ($title) {
			$name = $title;
		} else {
			$name = $url;
			$name =~ s/http:\/\/(\S+?)\/\S*/$1/;
		}
		$body = 'TrackBack';
		if ($blog_name) {
			$body .= ' from ' . $blog_name;
		}
		if ($excerpt) {
			$body .= ' : ' . $excerpt;
		}
		$name =~ s/"/&quot;/g;
		$body =~ s/"/&quot;/g;
		$name =~ s/</&lt;/g;
		$body =~ s/</&lt;/g;
		$name =~ s/>/&gt;/g;
		$body =~ s/>/&gt;/g;
		$body =~ s/\r?\n/<br>/gsm;
		$name_tmp = "<a href=\"$url\">$name</a>";
		$latest_id++;
		$com_hash{$latest_id}{n} = $name_tmp;
		$com_hash{$latest_id}{m} = $body;
		$com_hash{$latest_id}{d} = $what_time_is_it_now;

		write_to_logfile();	# Ot@Cւ̏
		write_to_jsfile($fn_pref.".js"); # JavaScript Feed t@Cւ̏
		write_to_adminlogfile(); # ǗҗpOt@Cւ̏

		print << 'END';
Content-type: text/xml

<?xml version="1.0" encoding="utf-8"?>
<response>
<error>0</error>
</response>
END
	} else {
		&error('Client URL is missing.');
	}

} else {
	&error("Can't understand request.");
}

sub error ($) {
	my $msg = shift;
	print << "END";
Content-type: text/xml

<?xml version="1.0" encoding="utf-8"?>
<response>
<error>1</error>
<message>$msg</message>
</response>
END
	exit;
}


### t@Cǂ
sub read_file {
    my ($fn, $strp) = @_;
#    if (-e $fn and -s $fn != 0) {
    if (-e $fn) {
	open(F, $fn) or die "can't open $fn : $!\n";
	$$strp = join('', <F>);
	close(F);
    }
}


### t@CZ[u
sub save_file {
    my ($fn, $strp) = @_;
    open(F, "> $fn") or die "can't open $fn : $!\n";
    flock(F, 2);
    print F $$strp;
    close F;
}


### RgOt@C͂AeRgƂ hash Ɋi[B
sub set_comment_hash {
    my ($hashp, $allp) = @_;
    foreach (split(/\r?\n/, $$allp)) {
	if (/^([nmd])\[(\d+)\] = "(.*?)";$/) {
	    $hashp->{$2}{$1} = $3;
	    $latest_id = $2 if ($latest_id < $2);
	}
    }
}

### Ot@Cւ̏
sub write_to_logfile {
    my $fn = "$fn_pref.log";
    my $str;
    foreach (sort {$a <=> $b} keys %com_hash) {
	$str .= qq(n[$_] = "$com_hash{$_}{n}";\nm[$_] = "$com_hash{$_}{m}";
d[$_] = "$com_hash{$_}{d}";\n);
    }
    save_file($fn, \$str);
}


### JavaScript Feed t@Cւ̏
sub write_to_jsfile {
    my ($jsfn) = @_;
#    my $jsfn = "$fn_pref.js";
    my $str = "";
    my $cnt = $kb_js_display_max;
    for (my $i = $latest_id; $i >= 0; $i--) {
	next unless defined $com_hash{$i};

	my ($n,$m,$d)  = ($com_hash{$i}{n},$com_hash{$i}{m},$com_hash{$i}{d});
	$n =~ s/^(.{1000}).*$/$1/;
	$m =~ s/<br>//ig;	# s^O͍폜

	$n =~ s/\\/\\\\/g;
	$m =~ s/\\/\\\\/g;

	$n =~ s/\'/\\'/g;
	$m =~ s/\'/\\'/g;

	# Ƃ̖Jbg - charsetɂ肠邩
	if ($m =~ s/^(([\x80-\xff].|[\x00-\x7f]){$kb_js_strlen_max}).*$/$1/) {
	    $m =~ s/((s?https?|ftp):\/\/$URLCHARS+)$/$2/;
	    $m .= "...";
	}
	# URL to anchor
	$m =~ s/((s?https?|ftp):\/\/$URLCHARS+)/<a href="$1">$1<\/a>/ig;

	$str .= << "JS";
document.writeln('<p><span class="canchor">_</span>');
document.writeln('<span class="commentator">$n</span>');
document.writeln(' [$m]</p>');
JS
    ;

	$cnt--;
	last if ($cnt <= 0);
    }
    if ((keys %com_hash) > $kb_js_display_max) {
	$str .= << "JS";
document.writeln('<p><span class="canchor">_</span>');
document.writeln('<span class="commentator">...</span></p>');
JS
    ;
    }

    save_file($jsfn, \$str);
}


### ǗҗpOt@Cւ̏
sub write_to_adminlogfile {
    my $str = "remote_host: ". $q->remote_host(). "\n";
    $str .= "id: $logid\n";
    $str .= "mail or url: $url\n";
    $str .= << "ADD";		# ǉe
n[$latest_id] = "$name";
m[$latest_id] = "$body";
d[$latest_id] = "$what_time_is_it_now";

ADD
    ;
    open(F, ">> $admin_log_file") or die "can't open $admin_log_file : $!\n";
    flock(F, 2);
    print F $str;
    close(F);
}

### TrackBackXgoRSS̃Gg𐶐
sub make_tb_list_rss {
	my ($commentp, $commentid) = @_;
	my $rv;
	if ($commentp->{'m'} =~ /^TrackBack(?: from .+)? : .+$/s && $commentp->{'n'} =~ /^<a href="(http:\/\/$URLCHARS+?)">(.+)<\/a>$/) {
		my $title = $2;
		my $link = $1;
		my $desc = $commentp->{'m'};
		$desc =~ s/^.+? : //;
		$desc =~ s/<.+?>//g;

		$title = Jcode->new($title,'sjis')->utf8;
		$desc = Jcode->new($desc,'sjis')->utf8;

		$rv = << "END"
<item>
<title>$title</title>
<link>$link</link>
<description>$desc</description>
</item>
END
;
	}
return $rv;
}
