#
# HTML̎̎QƂ\i\Lɕϊ
#
# Copyright Kissui Shimotsuki <shimotsuki@ikushimo.com>
#
# USAGE
#
# require './entities.pl';
# $after_translate = &translate_entities($before_translate);
#

sub translate_entities {
	my $transdata = shift @_;
	$transdata =~ s/&nbsp;/&#160;/g;
	$transdata =~ s/&iexcl;/&#161;/g;
	$transdata =~ s/&cent;/&#162;/g;
	$transdata =~ s/&pound;/&#163;/g;
	$transdata =~ s/&curren;/&#164;/g;
	$transdata =~ s/&yen;/&#165;/g;
	$transdata =~ s/&brvbar;/&#166;/g;
	$transdata =~ s/&sect;/&#167;/g;
	$transdata =~ s/&uml;/&#168;/g;
	$transdata =~ s/&copy;/&#169;/g;
	$transdata =~ s/&ordf;/&#170;/g;
	$transdata =~ s/&laquo;/&#171;/g;
	$transdata =~ s/&not;/&#172;/g;
	$transdata =~ s/&shy;/&#173;/g;
	$transdata =~ s/&reg;/&#174;/g;
	$transdata =~ s/&macr;/&#175;/g;
	$transdata =~ s/&deg;/&#176;/g;
	$transdata =~ s/&plusmn;/&#177;/g;
	$transdata =~ s/&sup2;/&#178;/g;
	$transdata =~ s/&sup3;/&#179;/g;
	$transdata =~ s/&acute;/&#180;/g;
	$transdata =~ s/&micro;/&#181;/g;
	$transdata =~ s/&para;/&#182;/g;
	$transdata =~ s/&middot;/&#183;/g;
	$transdata =~ s/&cedil;/&#184;/g;
	$transdata =~ s/&sup1;/&#185;/g;
	$transdata =~ s/&ordm;/&#186;/g;
	$transdata =~ s/&raquo;/&#187;/g;
	$transdata =~ s/&frac14;/&#188;/g;
	$transdata =~ s/&frac12;/&#189;/g;
	$transdata =~ s/&frac34;/&#190;/g;
	$transdata =~ s/&iquest;/&#191;/g;
	$transdata =~ s/&Agrave;/&#192;/g;
	$transdata =~ s/&Aacute;/&#193;/g;
	$transdata =~ s/&Acirc;/&#194;/g;
	$transdata =~ s/&Atilde;/&#195;/g;
	$transdata =~ s/&Auml;/&#196;/g;
	$transdata =~ s/&Aring;/&#197;/g;
	$transdata =~ s/&AElig;/&#198;/g;
	$transdata =~ s/&Ccedil;/&#199;/g;
	$transdata =~ s/&Egrave;/&#200;/g;
	$transdata =~ s/&Eacute;/&#201;/g;
	$transdata =~ s/&Ecirc;/&#202;/g;
	$transdata =~ s/&Euml;/&#203;/g;
	$transdata =~ s/&Igrave;/&#204;/g;
	$transdata =~ s/&Iacute;/&#205;/g;
	$transdata =~ s/&Icirc;/&#206;/g;
	$transdata =~ s/&Iuml;/&#207;/g;
	$transdata =~ s/&ETH;/&#208;/g;
	$transdata =~ s/&Ntilde;/&#209;/g;
	$transdata =~ s/&Ograve;/&#210;/g;
	$transdata =~ s/&Oacute;/&#211;/g;
	$transdata =~ s/&Ocirc;/&#212;/g;
	$transdata =~ s/&Otilde;/&#213;/g;
	$transdata =~ s/&Ouml;/&#214;/g;
	$transdata =~ s/&times;/&#215;/g;
	$transdata =~ s/&Oslash;/&#216;/g;
	$transdata =~ s/&Ugrave;/&#217;/g;
	$transdata =~ s/&Uacute;/&#218;/g;
	$transdata =~ s/&Ucirc;/&#219;/g;
	$transdata =~ s/&Uuml;/&#220;/g;
	$transdata =~ s/&Yacute;/&#221;/g;
	$transdata =~ s/&THORN;/&#222;/g;
	$transdata =~ s/&szlig;/&#223;/g;
	$transdata =~ s/&agrave;/&#224;/g;
	$transdata =~ s/&aacute;/&#225;/g;
	$transdata =~ s/&acirc;/&#226;/g;
	$transdata =~ s/&atilde;/&#227;/g;
	$transdata =~ s/&auml;/&#228;/g;
	$transdata =~ s/&aring;/&#229;/g;
	$transdata =~ s/&aelig;/&#230;/g;
	$transdata =~ s/&ccedil;/&#231;/g;
	$transdata =~ s/&egrave;/&#232;/g;
	$transdata =~ s/&eacute;/&#233;/g;
	$transdata =~ s/&ecirc;/&#234;/g;
	$transdata =~ s/&euml;/&#235;/g;
	$transdata =~ s/&igrave;/&#236;/g;
	$transdata =~ s/&iacute;/&#237;/g;
	$transdata =~ s/&icirc;/&#238;/g;
	$transdata =~ s/&iuml;/&#239;/g;
	$transdata =~ s/&eth;/&#240;/g;
	$transdata =~ s/&ntilde;/&#241;/g;
	$transdata =~ s/&ograve;/&#242;/g;
	$transdata =~ s/&oacute;/&#243;/g;
	$transdata =~ s/&ocirc;/&#244;/g;
	$transdata =~ s/&otilde;/&#245;/g;
	$transdata =~ s/&ouml;/&#246;/g;
	$transdata =~ s/&divide;/&#247;/g;
	$transdata =~ s/&oslash;/&#248;/g;
	$transdata =~ s/&ugrave;/&#249;/g;
	$transdata =~ s/&uacute;/&#250;/g;
	$transdata =~ s/&ucirc;/&#251;/g;
	$transdata =~ s/&uuml;/&#252;/g;
	$transdata =~ s/&yacute;/&#253;/g;
	$transdata =~ s/&thorn;/&#254;/g;
	$transdata =~ s/&yuml;/&#255;/g;
	$transdata =~ s/&fnof;/&#402;/g;
	$transdata =~ s/&Alpha;/&#913;/g;
	$transdata =~ s/&Beta;/&#914;/g;
	$transdata =~ s/&Gamma;/&#915;/g;
	$transdata =~ s/&Delta;/&#916;/g;
	$transdata =~ s/&Epsilon;/&#917;/g;
	$transdata =~ s/&Zeta;/&#918;/g;
	$transdata =~ s/&Eta;/&#919;/g;
	$transdata =~ s/&Theta;/&#920;/g;
	$transdata =~ s/&Iota;/&#921;/g;
	$transdata =~ s/&Kappa;/&#922;/g;
	$transdata =~ s/&Lambda;/&#923;/g;
	$transdata =~ s/&Mu;/&#924;/g;
	$transdata =~ s/&Nu;/&#925;/g;
	$transdata =~ s/&Xi;/&#926;/g;
	$transdata =~ s/&Omicron;/&#927;/g;
	$transdata =~ s/&Pi;/&#928;/g;
	$transdata =~ s/&Rho;/&#929;/g;
	$transdata =~ s/&Sigma;/&#931;/g;
	$transdata =~ s/&Tau;/&#932;/g;
	$transdata =~ s/&Upsilon;/&#933;/g;
	$transdata =~ s/&Phi;/&#934;/g;
	$transdata =~ s/&Chi;/&#935;/g;
	$transdata =~ s/&Psi;/&#936;/g;
	$transdata =~ s/&Omega;/&#937;/g;
	$transdata =~ s/&alpha;/&#945;/g;
	$transdata =~ s/&beta;/&#946;/g;
	$transdata =~ s/&gamma;/&#947;/g;
	$transdata =~ s/&delta;/&#948;/g;
	$transdata =~ s/&epsilon;/&#949;/g;
	$transdata =~ s/&zeta;/&#950;/g;
	$transdata =~ s/&eta;/&#951;/g;
	$transdata =~ s/&theta;/&#952;/g;
	$transdata =~ s/&iota;/&#953;/g;
	$transdata =~ s/&kappa;/&#954;/g;
	$transdata =~ s/&lambda;/&#955;/g;
	$transdata =~ s/&mu;/&#956;/g;
	$transdata =~ s/&nu;/&#957;/g;
	$transdata =~ s/&xi;/&#958;/g;
	$transdata =~ s/&omicron;/&#959;/g;
	$transdata =~ s/&pi;/&#960;/g;
	$transdata =~ s/&rho;/&#961;/g;
	$transdata =~ s/&sigmaf;/&#962;/g;
	$transdata =~ s/&sigma;/&#963;/g;
	$transdata =~ s/&tau;/&#964;/g;
	$transdata =~ s/&upsilon;/&#965;/g;
	$transdata =~ s/&phi;/&#966;/g;
	$transdata =~ s/&chi;/&#967;/g;
	$transdata =~ s/&psi;/&#968;/g;
	$transdata =~ s/&omega;/&#969;/g;
	$transdata =~ s/&thetasym;/&#977;/g;
	$transdata =~ s/&upsih;/&#978;/g;
	$transdata =~ s/&piv;/&#982;/g;
	$transdata =~ s/&bull;/&#8226;/g;
	$transdata =~ s/&hellip;/&#8230;/g;
	$transdata =~ s/&prime;/&#8242;/g;
	$transdata =~ s/&Prime;/&#8243;/g;
	$transdata =~ s/&oline;/&#8254;/g;
	$transdata =~ s/&frasl;/&#8260;/g;
	$transdata =~ s/&weierp;/&#8472;/g;
	$transdata =~ s/&image;/&#8465;/g;
	$transdata =~ s/&real;/&#8476;/g;
	$transdata =~ s/&trade;/&#8482;/g;
	$transdata =~ s/&alefsym;/&#8501;/g;
	$transdata =~ s/&larr;/&#8592;/g;
	$transdata =~ s/&rarr;/&#8594;/g;
	$transdata =~ s/&darr;/&#8595;/g;
	$transdata =~ s/&harr;/&#8596;/g;
	$transdata =~ s/&crarr;/&#8629;/g;
	$transdata =~ s/&lArr;/&#8656;/g;
	$transdata =~ s/&uArr;/&#8657;/g;
	$transdata =~ s/&rArr;/&#8658;/g;
	$transdata =~ s/&dArr;/&#8659;/g;
	$transdata =~ s/&hArr;/&#8660;/g;
	$transdata =~ s/&forall;/&#8704;/g;
	$transdata =~ s/&part;/&#8706;/g;
	$transdata =~ s/&exist;/&#8707;/g;
	$transdata =~ s/&empty;/&#8709;/g;
	$transdata =~ s/&nabla;/&#8711;/g;
	$transdata =~ s/&isin;/&#8712;/g;
	$transdata =~ s/&notin;/&#8713;/g;
	$transdata =~ s/&ni;/&#8715;/g;
	$transdata =~ s/&prod;/&#8719;/g;
	$transdata =~ s/&sum;/&#8721;/g;
	$transdata =~ s/&minus;/&#8722;/g;
	$transdata =~ s/&lowast;/&#8727;/g;
	$transdata =~ s/&radic;/&#8730;/g;
	$transdata =~ s/&prop;/&#8733;/g;
	$transdata =~ s/&infin;/&#8734;/g;
	$transdata =~ s/&ang;/&#8736;/g;
	$transdata =~ s/&and;/&#8743;/g;
	$transdata =~ s/&or;/&#8744;/g;
	$transdata =~ s/&cap;/&#8745;/g;
	$transdata =~ s/&cup;/&#8746;/g;
	$transdata =~ s/&int;/&#8747;/g;
	$transdata =~ s/&there4;/&#8756;/g;
	$transdata =~ s/&sim;/&#8764;/g;
	$transdata =~ s/&cong;/&#8773;/g;
	$transdata =~ s/&asymp;/&#8776;/g;
	$transdata =~ s/&ne;/&#8800;/g;
	$transdata =~ s/&equiv;/&#8801;/g;
	$transdata =~ s/&le;/&#8804;/g;
	$transdata =~ s/&ge;/&#8805;/g;
	$transdata =~ s/&sub;/&#8834;/g;
	$transdata =~ s/&sup;/&#8835;/g;
	$transdata =~ s/&nsub;/&#8836;/g;
	$transdata =~ s/&sube;/&#8838;/g;
	$transdata =~ s/&supe;/&#8839;/g;
	$transdata =~ s/&oplus;/&#8853;/g;
	$transdata =~ s/&otimes;/&#8855;/g;
	$transdata =~ s/&perp;/&#8869;/g;
	$transdata =~ s/&sdot;/&#8901;/g;
	$transdata =~ s/&lceil;/&#8968;/g;
	$transdata =~ s/&rceil;/&#8969;/g;
	$transdata =~ s/&lfloor;/&#8970;/g;
	$transdata =~ s/&rfloor;/&#8971;/g;
	$transdata =~ s/&lang;/&#9001;/g;
	$transdata =~ s/&rang;/&#9002;/g;
	$transdata =~ s/&loz;/&#9674;/g;
	$transdata =~ s/&spades;/&#9824;/g;
	$transdata =~ s/&clubs;/&#9827;/g;
	$transdata =~ s/&hearts;/&#9829;/g;
	$transdata =~ s/&diams;/&#9830;/g;
	$transdata =~ s/&quot;/&#34;/g;
	$transdata =~ s/&amp;/&#38;/g;
	$transdata =~ s/&lt;/&#60;/g;
	$transdata =~ s/&gt;/&#62;/g;
	$transdata =~ s/&OElig;/&#338;/g;
	$transdata =~ s/&oelig;/&#339;/g;
	$transdata =~ s/&Scaron;/&#352;/g;
	$transdata =~ s/&scaron;/&#353;/g;
	$transdata =~ s/&Yuml;/&#376;/g;
	$transdata =~ s/&circ;/&#710;/g;
	$transdata =~ s/&tilde;/&#732;/g;
	$transdata =~ s/&ensp;/&#8194;/g;
	$transdata =~ s/&emsp;/&#8195;/g;
	$transdata =~ s/&thinsp;/&#8201;/g;
	$transdata =~ s/&zwnj;/&#8204;/g;
	$transdata =~ s/&zwj;/&#8205;/g;
	$transdata =~ s/&lrm;/&#8206;/g;
	$transdata =~ s/&rlm;/&#8207;/g;
	$transdata =~ s/&ndash;/&#8211;/g;
	$transdata =~ s/&mdash;/&#8212;/g;
	$transdata =~ s/&lsquo;/&#8216;/g;
	$transdata =~ s/&rsquo;/&#8217;/g;
	$transdata =~ s/&sbquo;/&#8218;/g;
	$transdata =~ s/&ldquo;/&#8220;/g;
	$transdata =~ s/&rdquo;/&#8221;/g;
	$transdata =~ s/&bdquo;/&#8222;/g;
	$transdata =~ s/&dagger;/&#8224;/g;
	$transdata =~ s/&Dagger;/&#8225;/g;
	$transdata =~ s/&permil;/&#8240;/g;
	$transdata =~ s/&lsaquo;/&#8249;/g;
	$transdata =~ s/&rsaquo;/&#8250;/g;
	$transdata =~ s/&euro;/&#8364;/g;
	return ($transdata);
}

1;
